#include <stdlib.h>

#include "obj_dir/Vga.h"
#include "tb.h"

// Реальная скорость выше в 8 раз
// Симуляция 3.125 Мгц = 125000
// 1 млн x 25 загрузка 100% хост-процессора
#define CLOCK_FRAME (125000*8)

int main(int argc, char **argv) {

    Main* app = new Main(640, 400, 2, 25);

    // Видеопамять
    int memory[8192];

    // Загрузить шрифты и видеообласть
    for (int i = 0; i < 4096; i++) memory[i] = asciicp866[i];
    for (int i = 0; i < 2048; i++) {
        memory[2*i+4096] = i;
        memory[2*i+4097] = 0x17;
    }

    // -------------------------------------
    Verilated::commandArgs(argc, argv);
    Vga* vga = new Vga;
    // -------------------------------------

    vga->cursor = 0;

    // Обработка возникшего события
    while (int event = app->event()) {

        // 1 кадр = 1 млн тактов
        if (event == EvtRedraw) {

            for (int i = 0; i < CLOCK_FRAME; i++) {

                // Интерфейс памяти
                vga->data = memory[ vga->address ] & 255;

                // Исполнение одногот такта
                vga->clock = 0; vga->eval();
                vga->clock = 1; vga->eval();

                app->vga(vga->R<<4, vga->G<<4, vga->B<<4, vga->HS, vga->VS, 1);
            }

            if (Verilated::gotFinish()) break;
        }
    }

    delete app;
    delete vga;

    exit(EXIT_SUCCESS);
}
